{   NES-Copy version 0.1a
                          .                 .
                            ______ ______ .
                         .:_\_ .  \\_ .__\_::.
                      . .::./ ./  // ./__ .:::. .
                         :_<_____/<______>_:.
                         .                 .
                         Damaged Cybernetics
                  http://www.futureone.com/~damaged/

    It is a crime to redistribute these routines in a commercial
    venture of any kind without permission or a licensing agreement.
    Contact us via email for more information on licensing.

    This is freely distributable for non-commercial use, however we
    require that you acknowledge the following:

    Copyright (c) 1996 DiskDude. All rights reserved.

    If you have any questions or comments, please contact any of the
    following people via the Internet:

      Donald Moore    (MindRape)    moore@futureone.com
      John Pappas     (DiskDude)    papa@internex.net.au
      Jeremy Chadwick (Yoshi)       yoshi@crystalis.com
      Donald Staheli  (Royce)       drs@futureone.com
      Chris Cheney    (Calc)        calc@crystalis.com
      Chris George    (The Brain)   thebrain@icehouse.com
      Charles Doty    (KrazyOne)    cdoty@host.yab.com
}
program NESCopy; {NESCopy.exe}
uses dos, crt;

type  io_mode      = (rPRG, wPRG, rCHR, wCHR, rSRAM, wSRAM, dALL);
const bsize        = 8*1024-1;             {Buffer size}
      delay_factor = 10;                   {delay factor}

var fhnd : file;                           {File handle}
    prt  : word;                           {Our port address}
    tmp  : string;                         {Temporary string used for lots of stuff}
    buf  : array[0..bsize] of char;        {Our read/write buffer for image data}

procedure delay;
var t : longint;
begin
     for t:=0 to delay_factor do;
end;
{
  Read a byte of data from the data input buffer
}
function read_data_nes : char;
var data : byte;
begin
     asm
        MOV DX, WORD PTR [prt]
        INC DX
        INC DX       {we want prt+2 -> control port address}
        MOV AL, $2   {0010}
        XOR AL, $b   {all bits inverted except bit 3 by port}
        OR  AL, $a0  {enable bi-directional EPP/ECP mode}
        OUT DX, AL   {write control data -> select port C of 8225a}
        MOV DX, WORD PTR [prt]
        IN  AL, DX   {read the data from 8255a}
        MOV BYTE PTR [data], AL
     end;
     read_data_nes:=chr(data);
end;
{
  Write a byte of data to the data output buffer
}
procedure write_data_nes(data : char);
begin
     asm
        MOV DX, WORD PTR [prt]
        INC DX
        INC DX       {we want prt+2 -> control port address}
        MOV AL, $a   {1010}
        XOR AL, $b   {all bits inverted except bit 3 by port}
        OUT DX, AL   {write control data -> select port C of 8225a}
        MOV DX, WORD PTR [prt]
        MOV AL, BYTE PTR [data]
        OUT DX, AL   {write data to 8225a}
     end;
end;
{
  Write a byte of data to one of the address latches
}
procedure write_address_nes(address : word);
var lo_addr, hi_addr : byte;
begin
     lo_addr:=address and $FF;
     hi_addr:=(address and $FF00) shr 8;
     asm
        MOV DX, WORD PTR [prt]
        INC DX
        INC DX       {we want prt+2 -> control port address}
        MOV AL, $8   {1000}
        XOR AL, $b   {all bits inverted except bit 3 by port}
        OUT DX, AL   {write control data -> select port A of 8225a}
        MOV DX, WORD PTR [prt]
        MOV AL, BYTE PTR [lo_addr]
        OUT DX, AL   {write data to 8225a}

        MOV DX, WORD PTR [prt]
        INC DX
        INC DX       {we want prt+2 -> control port address}
        MOV AL, $9   {1001}
        XOR AL, $b   {all bits inverted except bit 3 by port}
        OUT DX, AL   {write control data -> select port B of 8225a}
        MOV DX, WORD PTR [prt]
        MOV AL, BYTE PTR [lo_addr]
        OUT DX, AL   {write data to 8225a}
     end;
end;
{
  Enable read/write mode to ROM/SRAM
}
procedure control(mode : io_mode);
     procedure write_mode(mode : byte);
     begin
        asm
           MOV DX, WORD PTR [prt]
           INC DX
           INC DX       {we want prt+2 -> control port address}
           MOV AL, $4   {0100}
           XOR AL, $b   {all bits inverted except bit 3 by port}
           OUT DX, AL   {write control data -> select 74ls374}
           MOV DX, WORD PTR [prt]
           MOV AL, BYTE PTR [mode]
           OUT DX, AL   {write data to 74ls374}
           {when the 74ls374 is deselected, the data will be latched}
        end;
     end;
     procedure write_8255_mode(mode : byte);
     begin
        asm
           MOV DX, WORD PTR [prt]
           INC DX
           INC DX       {we want prt+2 -> control port address}
           MOV AL, $b   {1011}
           XOR AL, $b   {all bits inverted except bit 3 by port}
           OUT DX, AL   {write control data -> select control port 8255a}
           MOV DX, WORD PTR [prt]
           MOV AL, BYTE PTR [mode]
           OUT DX, AL   {write data to 8225a}
        end;
     end;
begin
     case mode of
     rPRG : begin {read the PRG ROM}
                 write_8255_mode($80); {ports A, B and C are latched outputs}
                 write_mode($7b);      {<<<<<<<<<<------------ check this!!!}
            end;
     wPRG : begin
            end;
     rCHR : begin {read the CHR ROM}
                 write_8255_mode($80); {ports A, B and C are latched outputs}
                 write_mode($7e);      {<<<<<<<<<<------------ check this!!!}
            end;
     wCHR : begin
            end;
     rSRAM: begin
            end;
     wSRAM: begin
            end;
     dALL : begin {disable all IC's on cartridge}
                 write_mode($FF);
                 write_8255_mode($9b); {ports A, B and C are inputs}
            end;
     end;{case}
end;
{
  Do a bank switch
}
procedure switch_bank_nes(bank : byte);
begin
     {not implemented yet}
     write_address_nes(0);
end;
{
  Write a 16byte NES header
}
procedure header_nes(rom,vid : byte; var f : file);
var r : byte;
begin
     for r:=0 to 15 do buf[r]:=#0; {clear buffer}
     buf[0]:='N'; buf[1]:='E'; buf[2]:='S'; buf[3]:=#$1A;

     buf[4]:=chr(rom);              {pages of 16kbyte ROM}
     buf[5]:=chr(vid);              {pages of 8kbyte ROM/RAM}
     blockwrite(f,buf,16);          {Write buffer}
end;
{
  Auto-detect size of ROM; return no. of pages
}
function size_nes(mode : io_mode) : byte;
var  bank        : longint;
     base, block : array[0..15] of char;

     function block_match(base, block : array of char) : boolean;
     var t : byte;
     begin
         for t:=0 to 15 do
         if base[t]<>block[t] then
         begin
             block_match:=false;                 {Blocks don't match!}
             exit;                               {exit function}
         end;
         block_match:=true;                      {Blocks match!}
     end;
     procedure read_block(var block : array of char);
     var lo : longint;
     begin
         for lo:=0 to 15 do
         begin
             case mode of
             rCHR : write_address_nes(bank*8192+lo);
             rPRG : write_address_nes(bank*16384+lo);
             end;{case}
             block[lo]:=read_data_nes;  {Read data from cart}
         end;{for}
     end;
begin
     {enable cartrdige}
     control(mode);
     bank:=0;
     switch_bank_nes(bank);

     read_block(base);                      {read in base block}
     while not block_match(base, block) do
     begin
          inc(bank);                        {increment bank}
          if bank>32 then                   {No cart; no point in wasting time}
          begin
               size_nes:=0;
               exit;
          end;
          {switch to bank}
          switch_bank_nes(bank);
          read_block(block);                {read in block of data}
     end;
     size_nes:=bank;
end;
{
  Make an image of a NES kart to a disk file
}
procedure copy_kart;
var prg, chr  : byte;    {no of program and video pages respectively}
    pos       : longint;
    r         : integer;

    procedure write_data_to_disk(bytes : word);
    begin
         blockwrite(fhnd,buf,bytes,r);
         if r<>bytes then
         begin
              {Error writing to file}
              writeln('Error writing file: ',paramstr(2),#7);
              close(fhnd);
              halt(1);
         end;
    end;
    procedure read_page(banks : byte; bnksize : longint);
    var bank : byte;
        addr : longint;
    begin
         pos:=0;
         for bank:=0 to (banks-1) do
         begin
              {bank switch}
              switch_bank_nes(bank); delay;
              for addr:=(bank*(bnksize-1)) to ((bank*bnksize)+bnksize-1) do
              begin
                   write_address_nes(addr); delay;
                   buf[pos]:=read_data_nes; delay;

                   if pos=bsize then
                   begin
                        write_data_to_disk(sizeof(buf));
                        pos:=0;
                   end else inc(pos);
              end;
         end;{pages}
         if pos<>0 then write_data_to_disk(pos);
    end;
begin
     prg:=size_nes(rPRG);      {get no of PRG ROM banks}
     chr:=size_nes(rCHR);      {get no of CHR ROM banks}
     if chr=0 then
     begin
          writeln('No cartridge was found!',#7);
          halt;
     end;

     {Open the file to write to}
     assign(fhnd,paramstr(2));
     rewrite(fhnd,1);
     header_nes(prg,chr,fhnd); {write our 16byte header}

     {Copy the Program ROM...}
     writeln('Filename:     ',paramstr(2));
     writeln('Delay factor: ',delay_factor);
     writeln;
     writeln('Reading ',prg*16,'kb of program ROM...');
     control(rPRG);
     read_page(prg,16384);

     {Copy the Character ROM/RAM...}
     control(rCHR);
     writeln('Reading ',chr*8,'kb of character RAM/ROM...');
     read_page(chr,8192);

     {close our file}
     close(fhnd);
end;

{
  Load an image from a disk file to a NES ram kart
}
procedure load_kart;
begin
end;

{
  Make an image of a NES kart's SRAM to a disk file
}
procedure save_sram;
begin
end;

{
  Load an image from a disk file to a NES kart's SRAM
}
procedure load_sram;
begin
end;

procedure usage;
begin
     writeln('Usage: NESCopy [tool] [filename] [port]');
     writeln;
     writeln('[tool]:  c - Copy a cartridge');
     writeln('         l - Load a cartridge [not done]');
     writeln('         s - Save SRAM on cartridge [not done]');
     writeln('         o - Load SRAM on cartridge [not done]');
     writeln;
     writeln('[port]: /1 - LPT1: (default)');
     writeln('        /2 - LPT2:');
     writeln('        /3 - LPT3:');
     writeln;
     writeln(' E-mail: papa@internex.net.au');
     writeln(' WWW:    http://internex.net.au/~papa/NESCopy/');
     halt(1);
end;

begin
     {$I-}
     writeln('NES-Copy version 0.1a');
     writeln('Copyright (c) 1996 DiskDude. All rights reserved.');
     writeln('Brought to you by Damaged Cybernetics.');
     writeln;

     {Check to see if we have our 2 inputs}
     if (paramcount<2) or (paramcount>3) then usage;

     {Set port address}
     prt:=$378;
     if paramcount=3 then
     begin
          tmp:=paramstr(3);
          case tmp[2] of
          '2' : prt:=$278;
          '3' : prt:=$3bc;
          end;{case}
     end;

     {Now do what we are supposed to do, if we are
      given an invalid option (tool) then show usage}
     tmp:=paramstr(1);
     case upcase(tmp[1]) of
     'C' : copy_kart;
     'L' : usage;
     'S' : usage;
     'O' : usage;
     else usage;{Show usage}
     end;{case}

     {Disable all IC's on kart}
     control(dALL);
     writeln('Complete.');
end.